	
// MgmtInfoBase.h : CMgmtInfoBase ̐錾

#ifndef __MGMTINFOBASE_H_
#define __MGMTINFOBASE_H_

#include "resource.h"       // C V{
#include "mib.h"
#include "asn1.h"

/////////////////////////////////////////////////////////////////////////////
// CMgmtInfoBase
class ATL_NO_VTABLE CMgmtInfoBase : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CMgmtInfoBase, &CLSID_MgmtInfoBase>,
	public ISupportErrorInfo,
	public IObjectSafetyImpl<CMgmtInfoBase, INTERFACESAFE_FOR_UNTRUSTED_CALLER | INTERFACESAFE_FOR_UNTRUSTED_DATA>,
	public IDispatchImpl<IMgmtInfoBase, &IID_IMgmtInfoBase, &LIBID_SNMPCTLLib>
{
public:
	CMgmtInfoBase();

DECLARE_REGISTRY_RESOURCEID(IDR_MGMTINFOBASE)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMgmtInfoBase)
	COM_INTERFACE_ENTRY(IMgmtInfoBase)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
	COM_INTERFACE_ENTRY(IObjectSafety)
END_COM_MAP()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		if (m_mib)
			CMIB::DestroyTree(m_mib);
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IMgmtInfoBase
public:
	HRESULT STDMETHODCALLTYPE put_Prefix( 
            /* [in] */ BSTR NewVal);
        
	HRESULT STDMETHODCALLTYPE get_Prefix( 
            /* [retval][out] */ BSTR __RPC_FAR *pRetVal);
        
	HRESULT STDMETHODCALLTYPE InitNew( void);

	HRESULT STDMETHODCALLTYPE ReadObjId( 
            /* [in] */ BSTR ObjectString,
            /* [retval][out] */ VARIANT __RPC_FAR *pResult);
        
	HRESULT STDMETHODCALLTYPE PrintObjId( 
            /* [in] */ VARIANT ObjectId,
            /* [retval][out] */ BSTR __RPC_FAR *pResult);

private:
	CMIB* m_mib;
	std::string m_strPrefix;
	//
	void ChangePrefix(std::string&);
};

#endif //__MGMTINFOBASE_H_
