#ifndef _SNMPCTLCP_H_
#define _SNMPCTLCP_H_

template <class T>
class CProxy_ISNMPClientEvents : public IConnectionPointImpl<T, &DIID__ISNMPClientEvents, CComDynamicUnkArray>
{
	//Warning this class may be recreated by the wizard.
public:
	VOID Fire_OnData(LONG Reqid, ISNMPPDU * pPDU)
	{
		T* pT = static_cast<T*>(this);
		int nConnectionIndex;
		CComVariant* pvars = new CComVariant[2];
		int nConnections = m_vec.GetSize();
		
		for (nConnectionIndex = 0; nConnectionIndex < nConnections; nConnectionIndex++)
		{
			pT->Lock();
			CComPtr<IUnknown> sp = m_vec.GetAt(nConnectionIndex);
			pT->Unlock();
			IDispatch* pDispatch = reinterpret_cast<IDispatch*>(sp.p);
			if (pDispatch != NULL)
			{
				pvars[1] = Reqid;
				pvars[0] = pPDU;
				DISPPARAMS disp = { pvars, NULL, 2, 0 };
				HRESULT hr = pDispatch->Invoke(1, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &disp, NULL, NULL, NULL);
				ATLTRACE(_T("Invoke = %08X\n"), hr);
			}
		}
		delete[] pvars;
	
	}
	VOID Fire_OnError(LONG Reqid, LONG ErrorCode)
	{
		T* pT = static_cast<T*>(this);
		int nConnectionIndex;
		CComVariant* pvars = new CComVariant[2];
		int nConnections = m_vec.GetSize();
		
		for (nConnectionIndex = 0; nConnectionIndex < nConnections; nConnectionIndex++)
		{
			pT->Lock();
			CComPtr<IUnknown> sp = m_vec.GetAt(nConnectionIndex);
			pT->Unlock();
			IDispatch* pDispatch = reinterpret_cast<IDispatch*>(sp.p);
			if (pDispatch != NULL)
			{
				pvars[1] = Reqid;
				pvars[0] = ErrorCode;
				DISPPARAMS disp = { pvars, NULL, 2, 0 };
				HRESULT hr = pDispatch->Invoke(2, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_METHOD, &disp, NULL, NULL, NULL);
				ATLTRACE(_T("Invoke = %08X\n"), hr);
			}
		}
		delete[] pvars;
	
	}
};
#endif