	
// SNMPPDU.h : CSNMPPDU ̐錾

#ifndef __SNMPPDU_H_
#define __SNMPPDU_H_

#include "resource.h"       // C V{
#include "MgmtInfoBase.h"

const UINT PACKET_LENGTH = 4500;
const int MAX_NAME_LEN = 64;

typedef std::list<VARIANT> ListVars;
typedef std::list<VARIANT>::iterator VarsIter;
class CSNMPClient;
/////////////////////////////////////////////////////////////////////////////
// CSNMPPDU
class ATL_NO_VTABLE CSNMPPDU : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSNMPPDU, &CLSID_SNMPPDU>,
	public IDispatchImpl<ISNMPPDU, &IID_ISNMPPDU, &LIBID_SNMPCTLLib>
{
public:
	CSNMPPDU() : m_fResponse(false), m_Error(SNMP_ERR_NOERROR), m_ErrorIndex(0), 
		m_uReqid(SNMP_DEFAULT_REQID), m_pMgmtInfoBase(NULL)
	{
		m_pUnkMarshaler = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SNMPPDU)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSNMPPDU)
	COM_INTERFACE_ENTRY(ISNMPPDU)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		for (VarsIter it = m_listVars.begin(); it != m_listVars.end(); it++)
			VariantClear(&(*it));
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

	int GetPDU(LPBYTE&, CSNMPClient*);
	void SetPDU(int, LPBYTE);
	inline ULONG GetReqid() const { return m_uReqid; }
	inline void SetReqid(ULONG u) { m_uReqid = u; }
// ISNMPPDU
public:
	HRESULT STDMETHODCALLTYPE get_Command( 
            /* [retval][out] */ SNMPCommandConstants __RPC_FAR *pResult);
        
	HRESULT STDMETHODCALLTYPE put_Command( 
            /* [in] */ SNMPCommandConstants NewVal);
        
	HRESULT STDMETHODCALLTYPE get_ErrorStatus( 
            /* [retval][out] */ SNMPErrorStatusConstants __RPC_FAR *pResult);
        
	HRESULT STDMETHODCALLTYPE get_ErrorIndex( 
            /* [retval][out] */ long __RPC_FAR *pRetVal);
        
	HRESULT STDMETHODCALLTYPE get__NewEnum( 
            /* [retval][out] */ IUnknown __RPC_FAR *__RPC_FAR *ppResult);
        
	HRESULT STDMETHODCALLTYPE AddItem( 
            /* [in] */ ISNMPVariable __RPC_FAR *pNewVal);
        
	HRESULT STDMETHODCALLTYPE InitNew( void);

	HRESULT STDMETHODCALLTYPE put_MgmtInfoBase( 
            /* [in] */ IMgmtInfoBase __RPC_FAR *pNewVal);
        
	HRESULT STDMETHODCALLTYPE get_MgmtInfoBase( 
            /* [retval][out] */ IMgmtInfoBase __RPC_FAR *__RPC_FAR *ppRetVal);
private:
	SNMPCommandConstants m_Command;
	SNMPErrorStatusConstants m_Error;
	ULONG m_uReqid;
	long m_ErrorIndex;
	bool m_fResponse;
	ListVars m_listVars;
	static ULONG s_uReqid;
	IMgmtInfoBase* m_pMgmtInfoBase;
	LPBYTE build_var(LPBYTE, VARIANT&, int& length);
	LPBYTE build_null(LPBYTE data, int& datalength, BYTE type);
	LPBYTE build_objid(LPBYTE, int&, BYTE, VARIANT&);
	LPBYTE build_header(LPBYTE, int&, BYTE, int);
	LPBYTE build_length(LPBYTE data, int& datalength, int length);
	LPBYTE build_sequence(LPBYTE, int&, BYTE, int);
	LPBYTE build_int(LPBYTE, int&, BYTE, VARIANT&);
	LPBYTE build_int(LPBYTE, int&, BYTE, long);
	LPBYTE build_unsigned_int(LPBYTE, int&, BYTE, VARIANT&);
	LPBYTE build_string(LPBYTE, int&, BYTE, VARIANT&);
	LPBYTE build_string(LPBYTE, int&, BYTE, LPCSTR, int);
	LPBYTE build_unsigned_int64(LPBYTE, int&, BYTE, VARIANT&);
	LPBYTE build_auth(LPBYTE, int&, int, CSNMPClient*);
	//
	LPBYTE parse_auth(LPBYTE, int&, std::string&, long&);
	LPBYTE parse_header(LPBYTE, int&, long&);
	LPBYTE parse_length(LPBYTE, int&);
	LPBYTE parse_int(LPBYTE, int&, long&, long&);
	LPBYTE parse_unsigned_int(LPBYTE, int&, long&, ULONG&);
	LPBYTE parse_string(LPBYTE, int&, long&, std::string&);
	LPBYTE parse_var(LPBYTE, ISNMPVariable*, long&, int&);
	LPBYTE parse_objid(LPBYTE, int&, long&, VARIANT&);
	LPBYTE parse_unsigned_int64(LPBYTE, int&, long&, VARIANT&);
};

#endif //__SNMPPDU_H_
