// SNMPVariable.cpp : CSNMPVariable ̃Cve[V
#include "stdafx.h"
#include "SNMPCtl.h"
#include "SNMPClient.h"
#include "SNMPVariable.h"

/////////////////////////////////////////////////////////////////////////////
// CSNMPVariable
HRESULT STDMETHODCALLTYPE CSNMPVariable::get_Value( 
            /* [retval][out] */ VARIANT __RPC_FAR *pResult)
{
	if (!pResult) return E_POINTER;
	// pResultVariantClearsȂĂ͂ȂȂB[out]p[^!
	VariantInit(pResult);
	VariantCopy(pResult, &m_value);
	return S_OK;
}
        
HRESULT STDMETHODCALLTYPE CSNMPVariable::put_Value( 
            /* [in] */ VARIANT NewVal)
{
	VariantClear(&m_value);
	VariantCopy(&m_value, &NewVal);
	return S_OK;
}
        
HRESULT STDMETHODCALLTYPE CSNMPVariable::get_ObjId( 
            /* [retval][out] */ VARIANT __RPC_FAR *pResult)
{
	if (!pResult) return E_POINTER;

	VariantInit(pResult);
	VariantCopy(pResult, &m_oid);
	return S_OK;
}
        
HRESULT STDMETHODCALLTYPE CSNMPVariable::put_ObjId( 
            /* [in] */ VARIANT NewVal)
{
	if (m_pMgmtInfoBase == NULL) return Error(IDS_E_NOMIB);
	HRESULT hr = ChangeVarToOids(NewVal, m_oid);
	if (hr == S_OK)
	{
		BSTR bstr = NULL;
		hr = m_pMgmtInfoBase->PrintObjId(NewVal, &bstr);
		if (hr == S_OK && bstr)
		{
			m_strObjName = bstr;
			SysFreeString(bstr);
		}
		else
			return Error(IDS_E_OBJID);
	}
	return hr;
}
        
HRESULT STDMETHODCALLTYPE CSNMPVariable::get_ObjName( 
            /* [retval][out] */ BSTR __RPC_FAR *pResult)
{
	if (!pResult) return E_POINTER;
	*pResult = SysAllocString(m_strObjName.c_str());
	return S_OK;
}
        
HRESULT STDMETHODCALLTYPE CSNMPVariable::put_ObjName( 
            /* [in] */ BSTR NewVal)
{
	if (m_pMgmtInfoBase == NULL) return Error(IDS_E_NOMIB);
	// NULLF߂
	if (!NewVal) NewVal = L"";
	VariantClear(&m_oid);
	HRESULT hr = m_pMgmtInfoBase->ReadObjId(NewVal, &m_oid);
	if (hr == S_OK)
	{
		USES_CONVERSION;
		m_strObjName = NewVal;
	}
	else
		return Error(IDS_E_OBJNAME);
	return S_OK;
}
        
HRESULT STDMETHODCALLTYPE CSNMPVariable::get_Type( 
            /* [retval][out] */ ASN1Constants __RPC_FAR *pResult)
{
	if (!pResult) return E_POINTER;
	*pResult = m_type;
	return S_OK;
}
        
HRESULT STDMETHODCALLTYPE CSNMPVariable::put_Type( 
            /* [in] */ ASN1Constants NewVal)
{
	m_type = NewVal;
	return S_OK;
}

HRESULT STDMETHODCALLTYPE CSNMPVariable::put_MgmtInfoBase( 
            /* [in] */ IMgmtInfoBase __RPC_FAR *pNewVal)
{
	if (pNewVal == NULL) return E_POINTER;
	IMgmtInfoBase* pBase;
	HRESULT hr = pNewVal->QueryInterface(IID_IMgmtInfoBase, (void**)&pBase);
	if (hr == S_OK)
	{
		if (m_pMgmtInfoBase)
			m_pMgmtInfoBase->Release();
		m_pMgmtInfoBase = pBase;
	}
	return hr;
}
        
HRESULT STDMETHODCALLTYPE CSNMPVariable::get_MgmtInfoBase( 
            /* [retval][out] */ IMgmtInfoBase __RPC_FAR *__RPC_FAR *ppRetVal)
{
	if (!ppRetVal) return E_POINTER;
	if (m_pMgmtInfoBase == NULL) return Error(IDS_E_NOMIB);
	return m_pMgmtInfoBase->QueryInterface(IID_IMgmtInfoBase, (void**)ppRetVal);
}

STDMETHODIMP CSNMPVariable::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_ISNMPClient
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (::InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

HRESULT CSNMPVariable::ChangeVarToOids(VARIANT& ObjectId, VARIANT& vDst)
{
	SAFEARRAY* pAry = NULL;
	if ((ObjectId.vt & (VT_ARRAY | VT_BYREF)) == (VT_ARRAY | VT_BYREF))
		pAry = *ObjectId.pparray;
	else if (ObjectId.vt & VT_ARRAY)
		pAry = ObjectId.parray;
	else
		return Error("ObjectId must be an array.", GUID_NULL, DISP_E_BADVARTYPE);
	if (pAry->rgsabound[0].cElements == 0)
		return Error("No ObjectId", GUID_NULL, DISP_E_PARAMNOTFOUND);
	int vt = ObjectId.vt & ~(VT_ARRAY | VT_BYREF);
	VARIANT* pVar = NULL;
	long* pLong = NULL;
	short* pShort = NULL;
	LPBYTE pByte = NULL;
	if (vt == VT_I4)
		pLong = (long*)pAry->pvData;
	else if (vt == VT_I2)
		pShort = (short*)pAry->pvData;
	else if (vt == VT_VARIANT)
		pVar = (VARIANT*)pAry->pvData;
	else if (vt == VT_UI1)
		pByte = (LPBYTE)pAry->pvData;
	else
		return Error("ObjectId elements must be integers.", GUID_NULL, DISP_E_BADVARTYPE);
	ULONG* oids = (ULONG*)_alloca(pAry->rgsabound[0].cElements * sizeof(ULONG));
	for (int i = 0; i < pAry->rgsabound[0].cElements; i++)
	{
		if (pLong)
			oids[i] = *pLong++;
		else if (pShort)
			oids[i] = *pShort++;
		else if (pByte)
			oids[i] = *pByte++;
		else
		{
			VARIANT v;
			VariantInit(&v);
			HRESULT hr = VariantChangeType(&v, pVar, 0, VT_I4);
			if (hr != S_OK)
				return Error("ObjectId elements must be integers.", GUID_NULL, hr);
			oids[i] = v.lVal;
			pVar++;
		}
	}
	VariantClear(&vDst);
    SAFEARRAYBOUND rgsabound[1];    
	rgsabound[0].lLbound = 0;
    rgsabound[0].cElements = pAry->rgsabound[0].cElements;
	vDst.parray = SafeArrayCreate(VT_VARIANT, 1, rgsabound);
	if (vDst.parray == NULL) return E_OUTOFMEMORY;
	vDst.vt = VT_ARRAY | VT_VARIANT;
	VARIANT* vp = (VARIANT*)vDst.parray->pvData;
	for (i = 0; i < rgsabound[0].cElements; i++, vp++)
	{
		VariantInit(vp);
		vp->vt = VT_I4;
		vp->lVal = oids[i];
	}
	return S_OK;
}
