// SNMPVariable.h : CSNMPVariable ̐錾

#ifndef __SNMPVARIABLE_H_
#define __SNMPVARIABLE_H_

#include "resource.h"       // C V{
#include "MgmtInfoBase.h"

/////////////////////////////////////////////////////////////////////////////
// CSNMPVariable
class ATL_NO_VTABLE CSNMPVariable : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSNMPVariable, &CLSID_SNMPVariable>,
	public ISupportErrorInfo,
	public IObjectSafetyImpl<CSNMPVariable, INTERFACESAFE_FOR_UNTRUSTED_CALLER>,
	public IDispatchImpl<ISNMPVariable, &IID_ISNMPVariable, &LIBID_SNMPCTLLib>
{
public:
	CSNMPVariable() : m_type(ASN_NULL), m_pMgmtInfoBase(NULL)
	{
		VariantInit(&m_value);
		VariantInit(&m_oid);
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SNMPVARIABLE)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSNMPVariable)
	COM_INTERFACE_ENTRY(ISNMPVariable)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
	COM_INTERFACE_ENTRY(IObjectSafety)
END_COM_MAP()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		VariantClear(&m_oid);
		VariantClear(&m_value);
		if (m_pMgmtInfoBase)
			m_pMgmtInfoBase->Release();
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// ISNMPVariable
public:
	HRESULT STDMETHODCALLTYPE get_Value( 
            /* [retval][out] */ VARIANT __RPC_FAR *pResult);
        
	HRESULT STDMETHODCALLTYPE put_Value( 
            /* [in] */ VARIANT NewVal);
        
	HRESULT STDMETHODCALLTYPE get_ObjId( 
            /* [retval][out] */ VARIANT __RPC_FAR *pResult);
        
	HRESULT STDMETHODCALLTYPE put_ObjId( 
            /* [in] */ VARIANT NewVal);
        
	HRESULT STDMETHODCALLTYPE get_ObjName( 
            /* [retval][out] */ BSTR __RPC_FAR *pResult);
        
	HRESULT STDMETHODCALLTYPE put_ObjName( 
            /* [in] */ BSTR NewVal);
        
	HRESULT STDMETHODCALLTYPE get_Type( 
            /* [retval][out] */ ASN1Constants __RPC_FAR *pResult);
        
	HRESULT STDMETHODCALLTYPE put_Type( 
            /* [in] */ ASN1Constants NewVal);

	HRESULT STDMETHODCALLTYPE put_MgmtInfoBase( 
            /* [in] */ IMgmtInfoBase __RPC_FAR *pNewVal);
        
	HRESULT STDMETHODCALLTYPE get_MgmtInfoBase( 
            /* [retval][out] */ IMgmtInfoBase __RPC_FAR *__RPC_FAR *ppRetVal);
private:
	ASN1Constants m_type;
	std::wstring m_strObjName;
	VARIANT m_oid;
	VARIANT m_value;
	HRESULT ChangeVarToOids(VARIANT&, VARIANT&);
	IMgmtInfoBase* m_pMgmtInfoBase;
};

#endif //__SNMPVARIABLE_H_
